export default {
    methods: {
        // 用于多选
        doSubmit() {
            this.scopeData.data.value = this.selectArr
            this.$parent.$parent.doSelect(this.scopeData.data)
        },
        isArrSelected(val) {
            const that = this
            let key = that.scopeData.data.bindKey
            if (that.selectArr.map(it => it[key]).indexOf(val[key]) > -1) {
                return true
            }
            return false
        },
        getIndexOfArr(val) {
            const that = this
            let key = that.scopeData.data.bindKey
            return that.selectArr.map(it => it[key]).indexOf(val[key])
        },
        // 全选反选
        /**
         * @param {*} val 全选反选布尔值
         */
        handleSelectAllChange(val) {
            // 获取当前页面表格数据
            const tableData = this.$refs.table1.tableData
            this.isIndeterminate = false
            if(val) {
                this.isIndeterminate = false
                tableData.forEach((item) => {
                    this.$set(item, 'isChecked', true)
                    if (item.isChecked) {
                        !this.isArrSelected(item) && this.selectArr.push(item) // 存入已选数组记录
                    }
                })
            } else {
                tableData.forEach((item) => {
                    this.$set(item, 'isChecked', false)
                    const index = this.getIndexOfArr(item)
                    index > -1 && this.selectArr.splice(index, 1) // 从已选数组记录中删除
                })
                this.isIndeterminate = this.selectArr.length > 0
            }
            this.doSubmit()
        },
        // 选项框改变 用于多选
        /**
         * @param {*} val 选择的具体项对应的对象
         */
        handleSelectionChange(val) {
            const that = this
            if (val.isChecked) {
                if (!that.isArrSelected(val)) {
                    that.selectArr.push(val)
                }
            } else {
                that.selectArr.splice(that.getIndexOfArr(val), 1)
            }
            // 通过选择的数量来改变全选框的状态
            const tableData = this.$refs.table1.tableData
            const totalCount = tableData.length
            let selectedCount = 0
            tableData.forEach(item => {
                if (item.isChecked === true) {
                    selectedCount++
                }
            })
            this.isCheckAll = totalCount === selectedCount ? true : false
            this.isIndeterminate = selectedCount > 0 && selectedCount < totalCount || (selectedCount == 0 && this.selectArr.length > 0) 
            this.doSubmit()
        },
        /**
         * @description 清空已选项，包括跨页面
         */
        handleClear() {
            const tableData = this.$refs.table1.tableData
            tableData.forEach((item) => {
                this.$set(item, 'isChecked', false)
            })
            this.selectArr = []
            this.isCheckAll = false
            this.isIndeterminate = false
            this.doSubmit()
        }
    }
}
