import ResizeObserver from 'resize-observer-polyfill';

const isServer = typeof window === 'undefined';

/* istanbul ignore next */
const resizeHandler = function(entries) {
  for (let entry of entries) {
    const listeners = entry.target.__resizeListeners__ || [];
    if (listeners.length) {
      listeners.forEach(fn => {
        fn();
      });
    }
  }
};

/* istanbul ignore next */
export const addResizeListener = function(petrel, fn) {
  if (isServer) return;
  if (!petrel.__resizeListeners__) {
    petrel.__resizeListeners__ = [];
    petrel.__ro__ = new ResizeObserver(resizeHandler);
    petrel.__ro__.observe(petrel);
  }
  petrel.__resizeListeners__.push(fn);
};

/* istanbul ignore next */
export const removeResizeListener = function(petrel, fn) {
  if (!petrel || !petrel.__resizeListeners__) return;
  petrel.__resizeListeners__.splice(petrel.__resizeListeners__.indexOf(fn), 1);
  if (!petrel.__resizeListeners__.length) {
    petrel.__ro__.disconnect();
  }
};
